#!/bin/sh

log_file="/home/log/sys.log"
LOG_TRACE()
{
    echo "`date +'%Y-%m-%d %H:%M:%S'`: [TRACE] ${1}" >> $log_file
}
LOG_DEBUG()
{
    echo "`date +'%Y-%m-%d %H:%M:%S'`: [DEBUG] ${1}" >> $log_file
}
LOG_INFO()
{
    echo "`date +'%Y-%m-%d %H:%M:%S'`: [INFO] ${1}" >> $log_file
}
LOG_WARN()
{
    echo "`date +'%Y-%m-%d %H:%M:%S'`: [WARN] ${1}" >> $log_file
}
LOG_ERROR()
{
    echo "`date +'%Y-%m-%d %H:%M:%S'`: [ERROR] ${1}" >> $log_file
}
LOG_TO_LINES()
{
    log_temp="/home/log/temp"
    tail -${1} $log_file > $log_temp && mv &log_temp &log_file
}

echo 1 > /proc/sys/net/ipv4/conf/all/arp_ignore
echo 2 > /proc/sys/net/ipv4/conf/all/arp_announce

if [ -f "/etc/TZSET" ];
then
        LOG_INFO "source /etc/TZSET: '$(cat /etc/TZSET)'"
        source /etc/TZSET
fi

LOG_INFO "System started."

LOG_INFO "sys.log to 10000 lines."
LOG_TO_LINES 10000

LOG_INFO "Run RtcInit..."
cd /etc/rc5.d
chmod +x RtcInit

count=0     #retry times
while [ 0 -eq 0 ]
do
    LOG_DEBUG "Start RtcInit..."
    ./RtcInit >> $log_file

    # check
    if [ $? -eq 0 ]; then     
        LOG_INFO "RtcInit success."
        break;
    else
        LOG_WARN "RtcInit wrong..."
        let count++
        if [ ${count} -eq 6 ]; then     
            LOG_ERROR "RtcInit error (> 5times)!"
            break
        fi
        LOG_INFO "retry(RtcInit) in 2 seconds"
        sleep 2
    fi
done

LOG_INFO "copy stdout-stderr.log start..."
mv /run/media/mmcblk0p3/stdout-stderr-9.log /run/media/mmcblk0p3/stdout-stderr-10.log
mv /run/media/mmcblk0p3/stdout-stderr-8.log /run/media/mmcblk0p3/stdout-stderr-9.log
mv /run/media/mmcblk0p3/stdout-stderr-7.log /run/media/mmcblk0p3/stdout-stderr-8.log
mv /run/media/mmcblk0p3/stdout-stderr-6.log /run/media/mmcblk0p3/stdout-stderr-7.log
mv /run/media/mmcblk0p3/stdout-stderr-5.log /run/media/mmcblk0p3/stdout-stderr-6.log
mv /run/media/mmcblk0p3/stdout-stderr-4.log /run/media/mmcblk0p3/stdout-stderr-5.log
mv /run/media/mmcblk0p3/stdout-stderr-3.log /run/media/mmcblk0p3/stdout-stderr-4.log
mv /run/media/mmcblk0p3/stdout-stderr-2.log /run/media/mmcblk0p3/stdout-stderr-3.log
mv /run/media/mmcblk0p3/stdout-stderr-1.log /run/media/mmcblk0p3/stdout-stderr-2.log
mv /home/root/stdout-stderr.log /run/media/mmcblk0p3/stdout-stderr-1.log
LOG_INFO "copy stdout-stderr.log done..."

LOG_INFO "Start autossh"
cd /etc/rc5.d
chmod +x ./devops.sh
./devops.sh &
LOG_INFO "autossh started."

chmod +x ./reduceLog.sh
./reduceLog.sh &

chmod +x /usr/bin/monitorUpdate.sh
/usr/bin/monitorUpdate.sh >> /home/log/sys.log 2>&1 &

sleep 3

LOG_INFO "Start APP."

cd /home/root
chmod 777 ./*
./startup &
sleep 25; chmod +x /etc/rc5.d/scanip; /etc/rc5.d/scanip &

LOG_INFO "APP started."

sync
