#! /bin/sh

UPDATE_DIR=/home/root/storage/update
APP_DIR=/home/root

APP_FILE=libmrd_passengerflow.so
APP_SEARCH=mrd_search
SHELL_STARTUP=startup
SHELL_UPGRADE=xzUpgrade.sh
SHELL_WATCHDOG=watchDog

UPDATE_COMPRESS_FILE=${UPDATE_DIR}/softw.tar.gz
UPDATE_STATE=${UPDATE_DIR}/stat
UPDATE_SUCCESS=0
UPDATE_FAILURE=1
UPDATE_NECESSARY=2

cd ${UPDATE_DIR}

echo "==========> run update!!!! <=========== "

if [ -f ${UPDATE_COMPRESS_FILE} ]; then
	echo "==========> start uncompress softw.tar.gz"
	rm -f ${APP_FILE} ${APP_SEARCH} ${SHELL_STARTUP} ${SHELL_UPGRADE} ${SHELL_WATCHDOG}
	tar xvf ${UPDATE_COMPRESS_FILE} -C .
	if [ $? -eq 0 ]; then
		
		echo "==========> uncompress success, cp libmrd_passengerflow.so to lib"
		cp ${APP_FILE} /lib

		echo "==========> uncompress success, cp mrd_search startup xzUpgrade.sh to /home/root"
		cp ${APP_SEARCH} ${SHELL_STARTUP} ${SHELL_UPGRADE} ${SHELL_WATCHDOG} ${APP_DIR}

		rm -f ${UPDATE_COMPRESS_FILE}
		
		echo "==========> update success"
	fi
fi

