#!/bin/bash

# monitor process wsdd and onvif_srvd
# 20231121: 首次发版，监控两个进程；
# 20231225: 解决wsdd或者onvif闪退情况下pid文件还在无法重新启动进程问题

log_file="/home/log/sys.log"
echo "`date +'%Y-%m-%d %H:%M:%S'`: $0 started." >> $log_file

# 判断onvifEnable 不再需要，客流4.0无论true 或者false，都会启动onvif进程
# cat /home/Param/configCamera.toml | grep onvifEnable | grep true
# if [ $? -ne 0 ];then
#     echo "`date +'%Y-%m-%d %H:%M:%S'`: onvifEnable is not true. Exiting..." >> $log_file
#     exit 0
# fi

sleep 120
monitor_process()
{
    process2Exist=`ps | grep ${1} | grep -v grep`

    if [ $? -ne 0 ];then
        echo "`date +'%Y-%m-%d %H:%M:%S'`: ${1} not running. Restarting..." >> $log_file
        eval ${2}
        echo "`date +'%Y-%m-%d %H:%M:%S'`: ${1} started." >> $log_file
    fi
}

while true; do
    monitor_process "wsdd" "cd /home/root; rm wsdd.pid; ./S90wsdd start &"
    monitor_process "onvif_srvd" "cd /home/root; rm onvif_srvd.pid; ./S90onvif_srvd start &"

    sleep 30
done
