#!/bin/sh

unzip -o CameraConfigPkg.zip

res=$(uname -a | grep "xilinx")
if [[ "$res" != "" ]]
then
    echo "客流3.0"

    # library
    cd CameraConfigPkg/V3/library/
    unzip -o libMoveSenseCamera.zip
    unzip -o libmrd_passengerflow.zip
    unzip -o libevent_with_mbedtls.zip
    unzip -o preloadable_libiconv.zip
    unzip -o openssl.zip
    unzip -o rtty.zip
    cp preloadable_libiconv.so /lib/
    cp libev.so.4 /lib/
    chmod +x /lib/preloadable_libiconv.so
    cp libMoveSenseCamera.so /lib/
    cp -r libevent_with_mbedtls/* /lib/

    if [ ! -f /lib/libmrd_passengerflow.so ];
    then
        cp libmrd_passengerflow.so /lib/
    else
        echo "libmrd_passengerflow exist"
    fi

    cp -r openssl/* /usr/lib/
    cp -r openssl/* /lib/

    # cd ../rtsp
    # chmod +x lib/*
    # chmod +x bin/*
    # cp lib/* /lib
    # cp bin/* /bin
    # mkdir -p /usr/local/lib
    # cp -r lib/gstreamer-1.0  /usr/local/lib

    cd /lib/
    chmod +x libMoveSenseCamera.so
    # chmod +x libmrd_passengerflow.so
    chmod +x libevent.so
    chmod +x libevent-2.2.so
    chmod +x libevent-2.2.so.1
    chmod +x libevent-2.2.so.1.0.0
    chmod +x libevent_core.so
    chmod +x libevent_core-2.2.so
    chmod +x libevent_core-2.2.so.1
    chmod +x libevent_core-2.2.so.1.0.0
    chmod +x libevent_extra.so
    chmod +x libevent_extra-2.2.so
    chmod +x libevent_extra-2.2.so.1
    chmod +x libevent_extra-2.2.so.1.0.0
    chmod +x libevent_mbedtls.so
    chmod +x libevent_mbedtls-2.2.so
    chmod +x libevent_mbedtls-2.2.so.1
    chmod +x libevent_mbedtls-2.2.so.1.0.0
    chmod +x libevent_pthreads.so
    chmod +x libevent_pthreads-2.2.so
    chmod +x libevent_pthreads-2.2.so.1
    chmod +x libevent_pthreads-2.2.so.1.0.0
    chmod +x libmbedcrypto.so
    chmod +x libmbedcrypto.so.2.25.0
    chmod +x libmbedcrypto.so.6
    chmod +x libmbedtls.so
    chmod +x libmbedtls.so.2.25.0
    chmod +x libmbedtls.so.13
    chmod +x libmbedx509.so
    chmod +x libmbedx509.so.1
    chmod +x libmbedx509.so.2.25.0
    chmod +x libev.so.4

    cd /usr/lib/
    chmod +x libssl.so.1.1
    chmod +x libcrypto.so.1.1
    ln -s libssl.so.1.1 libssl.so
    ln -s libcrypto.so.1.1 libcrypto.so

    cd /lib/
    chmod +x libssl.so.1.1
    chmod +x libcrypto.so.1.1
    ln -s libssl.so.1.1 libssl.so
    ln -s libcrypto.so.1.1 libcrypto.so

    # PassengerFlowApp && netparams
    cd /home/root/CameraConfigPkg/V3/
    cp -r AppManage/* /home/root
    cd /home/root/APP
    chmod +x CX_APP0106

    cd /home/root/CameraConfigPkg/V3/config/

    chmod +x  devops.sh
    mv devops.sh /etc/rc5.d/

    if ! grep -q 'rtty' /home/root/APP/server.config; then
        echo '47.97.154.189:rtty:5912:Binocular Camera' >> /home/root/APP/server.config
    else
        sed -i '/rtty/d' /home/root/APP/server.config
        echo '47.97.154.189:rtty:5912:Binocular Camera' >> /home/root/APP/server.config
    fi

    chmod +x rtty
    mv rtty /usr/bin/

    devops_num=$(grep -c "devops.sh" "/etc/rc5.d/S98startUp.sh")
    if [ $devops_num -gt 0 ]
    then
        sed -i 's/devops.bak/devops.sh/g' S98startUp.sh
    else
        sed -i 's/devops.sh/devops.bak/g' S98startUp.sh
    fi  

    chmod +x S98startUp.sh
    mv S98startUp.sh /etc/rc5.d/
    mv RtcInit /etc/rc5.d/
    mv scanip /etc/rc5.d/
    mv watchDog /home/root/
    mv profile /etc

    if [ ! -f "/etc/TZSET" ];
    then
        mv TZSET /etc
    fi


    chmod +x S01networking
    mv S01networking /etc/rc5.d/

    chmod +x watchdogSys
    mv watchdogSys /usr/bin

    chmod +x wget
    mv wget /usr/bin

    chmod +x reduceLog.sh
    mv reduceLog.sh /etc/rc5.d/

    # mv configCamera.xml /home/Param/
    # mv configParam.dat /home/Param

    # no auto start counting
    chmod +x AutoStart
    mv AutoStart /home/Param

    chmod +x default.script
    cp default.script /usr/share/udhcpc/

    chmod +x monitorDHCP
    cp monitorDHCP /usr/bin
    chmod +x monitorUpdate.sh
    cp monitorUpdate.sh /usr/bin

    chmod +x avahi-autoipd
    chmod +x avahi-autoipd.action
    cp avahi-autoipd /usr/sbin/
    mkdir /etc/avahi/
    cp avahi-autoipd.action /etc/avahi/

    chmod +x hostapd
    chmod +x hostapd_cli
    cp hostapd hostapd_cli /usr/bin/
    cp hostapd.conf /etc/
    cp udhcpd.conf /etc/

    sync

    # mkdir
    mkdir /home/log

    rm /home/root/CX_APP
    rm /etc/AppManage/APP/CX_APP
    sync

    kernelLowerVer="0x1017xx"
    kernelVer=$(cat /home/root/stdout-stderr.log | grep "cameraInfo.firmwareVersion.kernelVersion" | awk '{print $2}')
    echo "target kernerl version is ${kernelLowerVer}"
    echo "cur kernel version is ${kernelVer}"
    if [ "$kernelVer" = "$kernelLowerVer" ];then
        echo "update kernel version 0x101706"
        cd /home/root/CameraConfigPkg/V3/config/
        cp ./image.ub /run/media/mmcblk0p1/PEC1-0201-400-V30-V00101706.ub
        mv /run/media/mmcblk0p1/PEC1-0201-400-V30-V00101706.ub /run/media/mmcblk0p1/image.ub
        sync
    else
            echo "There is no need for updating kernel"
    fi


else
    echo "客流4.0"

    # library
    cd CameraConfigPkg/V4/library/
    chmod +x ./lib/*
    cp lib/* /lib

    cd /lib/
    chmod +x libssl.so.1.1
    chmod +x libcrypto.so.1.1
    ln -s libssl.so.1.1 libssl.so
    ln -s libcrypto.so.1.1 libcrypto.so
    chmod +x libpaho-mqtt3as.so.1.3.12
    chmod +x libpaho-mqttpp3.so.1.2.0
    ln -s libpaho-mqtt3as.so.1.3.12 libpaho-mqtt3as.so.1
    ln -s libpaho-mqtt3as.so.1 libpaho-mqtt3as.so
    ln -s libpaho-mqttpp3.so.1.2.0 libpaho-mqttpp3.so.1
    ln -s libpaho-mqttpp3.so.1 libpaho-mqttpp3.so
    chmod +x libev.so.4
    chmod +x libssh2.so.1

    # timezone
    cd /home/root/CameraConfigPkg/V4/timezone/
    if [ ! -f "/etc/TZSET" ];
    then
        cp TZSET /etc
    fi


    # App
    cd /home/root/CameraConfigPkg/V4/
    chmod +x ./*
    cp -r AppManage/* /home/root

    # config
    cd /home/root/CameraConfigPkg/V4/config/
    # chmod 600 id_rsa.db
    # mv id_rsa.db  /home/root/.ssh

    chmod +x ./*
    mv devops.sh /etc/init.d/

    if ! grep -q 'rtty' /home/root/APP/server.config; then
        echo '47.97.154.189:rtty:5912:Binocular Camera' >> /home/root/APP/server.config
    else
        sed -i '/rtty/d' /home/root/APP/server.config
        echo '47.97.154.189:rtty:5912:Binocular Camera' >> /home/root/APP/server.config
    fi

    mv rtty /usr/bin/


    devops_num=$(grep -c "devops.sh" "/etc/init.d/S98startUp.sh") 
    if [ $devops_num -gt 0 ]
    then
        sed -i 's/devops.bak/devops.sh/g' S98startUp.sh
    else
        sed -i 's/devops.sh/devops.bak/g' S98startUp.sh
    fi

    mv S98startUp.sh /etc/init.d/
    mv S12watchdog /etc/init.d/
    mv RtcInit /etc/init.d/
    mv scanip /etc/init.d/
    mv find /usr/bin/
    mv tftp /usr/bin/
    mv wget /usr/bin
    mv curl /usr/bin/

    mkdir -p /etc/ssl/certs/
    mv cacert.pem /etc/ssl/certs/

    chmod +x monitorUpdate.sh
    cp monitorUpdate.sh /usr/bin
    mv reduceLog.sh /etc/init.d/
    mv monitorLog.sh /etc/init.d/
    mv profile /etc
    mv watchDog /home/root/
    # cp ntp_single.conf /etc
    # mv ntp_single.conf /etc/ntp.conf
    # mv configCamera.toml /home/Param
    # no auto start counting
    mv AutoStart /home/Param
    chmod +x networking
    mv networking /etc/init.d/    
    chmod +x default.script
    cp default.script /usr/share/udhcpc/

    # mkdir
    mkdir -p /home/log
    mkdir -p /var/lib/ntp

    if [ -f "/etc/init.d/S50usb" ];
    then
        mv /etc/init.d/S50usb /etc/init.d/usb_S50
    fi

    #version文件是否存在，存在则为新版本
    #新版本，是否存在multiDirPassengerDataBase,不存在则复制passengerFlowBase
    #旧版本，不需要处理，因为会直接使用之前的passengerFlowBase

    if [ -e "/home/root/CameraConfigPkg/V4/version" ]; then
        if [ ! -e "/home/root/APP/multiDirPassengerDataBase" ]; then
            if  [ -e "/home/root/APP/passengerDataBase" ]; then
                cp /home/root/APP/passengerDataBase /home/root/APP/multiDirPassengerDataBase
            fi
        fi
    fi

    if  [ -e "/home/root/APP/passengerDataBase" ]; then
        mv /home/root/APP/passengerDataBase /home/root/APP/passengerDataBase.bak
    fi

fi

rm -r /home/root/CameraConfigPkg/
rm -r /home/root/CameraConfigPkg.zip

sync
    